//+------------------------------------------------------------------+
//|                                            Mayler_Martingail.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double BuyPrice = 0.0000;
extern double SellPrice = 0.0000;
extern double Lot = 0.01;
extern int MagicBuy = 111;
extern int MagicSell = 222;



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
  
int OrdersTotalMagicbuy(int MagicBuy)
 {
   int j=0;
   int r;
   for (r=0;r<OrdersTotal();r++)
   {
     if(OrderSelect(r,SELECT_BY_POS,MODE_TRADES))
     {
        if (OrderMagicNumber()==MagicBuy) j++;
     }
   }   
 return(j); 
 }

int OrdersTotalMagicsell(int MagicSell)
{
   int d=0;
   int n;
   for (n=0;n<OrdersTotal();n++)
   {
     if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES))
     {
        if (OrderMagicNumber()==MagicSell) d++;
     }
   }    
 return(d);
 }
 
//int CloseBuyProfit(int CloseMagicBuy)
// {
//   int btp=0;
//   int bc;
//   for (bc=0;bc<OrdersTotal();bc++)
//   {
//     if(OrderSelect(bc,SELECT_BY_POS,MODE_HISTORY))
//     {
//        if (OrderMagicNumber()==MagicBuy) 
//          if(OrderClosePrice()==BuyPrice+TakeProfit) 
//          btp++;
//     }
//   }   
// return(btp); 
// }     
 
// int CloseSellProfit(int CloseMagicSell)
// {
//   int stp=0;
//   int sc;
//   for (sc=0;sc<OrdersTotal();sc++)
//   {
//     if(OrderSelect(sc,SELECT_BY_POS,MODE_HISTORY))
//     {
//        if (OrderMagicNumber()==MagicBuy) 
//            if(OrderClosePrice()==SellPrice-TakeProfit) stp++;
//     }
//   }   
// return(stp); 
// }     
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
double StopLoss = 0.0;
double TakeProfit = 0.0;
int SellOrder;
int BuyOrder;
int BuyOpen=0;
int SellOpen=0;
double NextLot;  
int CloseMagicSell;
int CloseMagicBuy;
int start()
  {
//----
StopLoss = BuyPrice - SellPrice;
TakeProfit = StopLoss;
if (OrdersTotalMagicbuy(MagicBuy)== 0)
   BuyOrder=OrderSend(Symbol(),OP_BUYSTOP,Lot,BuyPrice,3,BuyPrice-StopLoss,BuyPrice+TakeProfit," ",MagicBuy);
if (OrdersTotalMagicsell(MagicSell)== 0)
   SellOrder=OrderSend(Symbol(),OP_SELLSTOP,Lot,SellPrice,3,SellPrice+StopLoss,SellPrice-TakeProfit," ",MagicSell);

if (OrdersTotalMagicbuy(MagicBuy)>0)
   {
   for(int bol=0;bol<OrdersTotal();bol++)
     {
      if(OrderSelect(bol,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicBuy)
            if(OrderType()==OP_BUY) 
               {
               BuyOpen++;
               double BuyOpenLot=OrderLots();
               }
     }
   for(int ssl=0;ssl<OrdersTotal();ssl++)
     {
      if(OrderSelect(ssl,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicSell)
            if(OrderType()==OP_SELLSTOP) 
               double SellStopLot=OrderLots();
     }     
   if(BuyOpen>0 && SellStopLot<=BuyOpenLot) 
      {
      OrderDelete(SellOrder);
      SellOrder=OrderSend(Symbol(),OP_SELLSTOP,BuyOpenLot*2,SellPrice,3,SellPrice+StopLoss,SellPrice-TakeProfit," ",MagicSell);
      }
   }
//if(OrdersTotalMagicbuy(MagicBuy)== 0)
//       for(int sso=0;sso<OrdersTotal();sso++)
//     {
//      if(OrderSelect(sso,SELECT_BY_POS,MODE_TRADES))
//         if(OrderMagicNumber()==MagicSell)
//            if(OrderType()==OP_SELLSTOP) 
//               OrderDelete(OrderTicket());
//     }          
                
if (OrdersTotalMagicsell(MagicSell)>0)
   {
   for(int sol=0;sol<OrdersTotal();sol++)
     if(OrderSelect(sol,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicSell)
            if(OrderType()==OP_SELL)
               {
               SellOpen++;
               double SellOpenLot=OrderLots();
               }
      
   for(int bsl=0;bsl<();bsl++)
     {
      if(OrderSelect(bsl,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicBuy)
            if(OrderType()==OP_BUYSTOP) 
               double BuyStopLot=OrderLots();
     }
   if(SellOpen>0 && BuyStopLot<=SellOpenLot) 
      {
      OrderDelete(BuyOrder);     
      BuyOrder=OrderSend(Symbol(),OP_BUYSTOP,SellOpenLot*2,BuyPrice,3,BuyPrice-StopLoss,BuyPrice+TakeProfit," ",MagicBuy);
      }
   }
//if(OrdersTotalMagicsell(MagicSell)== 0)
//     for(int bso=0;bso<OrdersTotal();bso++)
//     {
//      if(OrderSelect(bso,SELECT_BY_POS,MODE_TRADES))
//         if(OrderMagicNumber()==MagicBuy)
//            if(OrderType()==OP_BUYSTOP) 
//               OrderDelete(OrderTicket());
//     }
                
//----
   return(0);
  }
//+------------------------------------------------------------------+